- name: Install Docker on VM
  hosts: ec2_instance
  become: true
  
  vars_files:
    - vars.yml

  tasks:

    - name: Check if Docker is installed
      shell: dpkg -s docker.io
      register: docker_status
      ignore_errors: true

    - name: Install Docker if not already installed
      shell: |
        sudo apt update && sudo apt install docker.io -y
      when: docker_status.rc != 0
      
    - name: Remove Old container
      shell: |
        if sudo docker ps -a --format '{{ container_name }}' | grep -q '{{ container_name }}'; then
          sudo docker rm -f {{ container_name }}
        fi
    
    - name: Remove Old Image
      shell: |
        if sudo docker images --quiet | grep -q .; then
          sudo docker image prune -af
        fi

    - name: Pull Docker image
      shell: docker pull {{ image_name }}:{{ image_tag }}

    - name: Run Docker container
      shell: docker run --name {{ container_name }} -p {{ container_port }} -d {{ image_name }}:{{ image_tag }}

